mkdir -p cov && cd cov && 
rm *
gcc --coverage -g -O0 ../boot.c
for i in ../test/*.c; do
    i=$(basename $i .c)
    echo "Running coverage for test '$i'"
    ./a.out < ../test/$i.c > /dev/null
    gcov a-boot.c
done

python3 -m gcovr --html-details --html-theme github.green -o report.html -r ..